
_MP3_Set_Volume:

;MP3_Driver.mbas,112 :: 		sub procedure MP3_Set_Volume
;MP3_Driver.mbas,113 :: 		Volume_Mono = Volume_Steps [Volume_Level_Pointer]
	MOVLW       _Volume_Steps+0
	ADDWF       _Volume_Level_Pointer+0, 0 
	MOVWF       TBLPTRL 
	MOVLW       hi_addr(_Volume_Steps+0)
	MOVWF       TBLPTRH 
	MOVLW       0
	ADDWFC      TBLPTRH, 1 
	MOVLW       higher_addr(_Volume_Steps+0)
	MOVWF       TBLPTRU 
	MOVLW       0
	ADDWFC      TBLPTRU, 1 
	TBLRD*+
	MOVFF       TABLAT+0, R1
	MOVF        R1, 0 
	MOVWF       _volume_Mono+0 
;MP3_Driver.mbas,114 :: 		data_in = Volume_Mono                  'Stuff value
	MOVF        R1, 0 
	MOVWF       _data_in+0 
	MOVLW       0
	MOVWF       _data_in+1 
;MP3_Driver.mbas,115 :: 		data_in = data_in << 8 + Volume_Mono
	MOVF        _data_in+0, 0 
	MOVWF       _data_in+1 
	CLRF        _data_in+0 
	MOVF        R1, 0 
	ADDWF       _data_in+0, 1 
	MOVLW       0
	ADDWFC      _data_in+1, 1 
;MP3_Driver.mbas,116 :: 		TMR0IE_bit         = 0                 'Disable Interrupt
	BCF         TMR0IE_bit+0, BitPos(TMR0IE_bit+0) 
;MP3_Driver.mbas,117 :: 		Volume_Save_State = MP3_State          'Save what the server is doing
	MOVF        _MP3_State+0, 0 
	MOVWF       _Volume_Save_State+0 
;MP3_Driver.mbas,118 :: 		MP3_State = Write_SCI_State            'This is to avoid Re-entry problems
	MOVLW       8
	MOVWF       _MP3_State+0 
;MP3_Driver.mbas,119 :: 		Address = SCI_VOL_ADDR
	MOVLW       11
	MOVWF       _Address+0 
;MP3_Driver.mbas,120 :: 		TMR0IE_bit         = 1                 'Let it run
	BSF         TMR0IE_bit+0, BitPos(TMR0IE_bit+0) 
;MP3_Driver.mbas,121 :: 		while MP3_State <> Idle nop wend       'Wait for it to finish
L__MP3_Set_Volume2:
	MOVF        _MP3_State+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L__MP3_Set_Volume3
	NOP
	GOTO        L__MP3_Set_Volume2
L__MP3_Set_Volume3:
;MP3_Driver.mbas,122 :: 		TMR0IE_bit         = 0                 'Going to restore the old state and let the server continue
	BCF         TMR0IE_bit+0, BitPos(TMR0IE_bit+0) 
;MP3_Driver.mbas,123 :: 		MP3_State = Volume_Save_State          'Back to whatever it was doing
	MOVF        _Volume_Save_State+0, 0 
	MOVWF       _MP3_State+0 
;MP3_Driver.mbas,124 :: 		TMR0IE_bit         = 1                 'Let it run now
	BSF         TMR0IE_bit+0, BitPos(TMR0IE_bit+0) 
;MP3_Driver.mbas,126 :: 		end sub
L_end_MP3_Set_Volume:
	RETURN      0
; end of _MP3_Set_Volume

_MP3_init:

;MP3_Driver.mbas,129 :: 		sub procedure MP3_init()
;MP3_Driver.mbas,131 :: 		MP3_CS_Direction  = 0                  'Configure MP3_CS as output
	BCF         TRISC1_bit+0, BitPos(TRISC1_bit+0) 
;MP3_Driver.mbas,132 :: 		MP3_CS            = 1                  'Deselect MP3_CS
	BSF         LATC1_bit+0, BitPos(LATC1_bit+0) 
;MP3_Driver.mbas,133 :: 		MP3_RST_Direction = 0                  'Configure MP3_RST as output
	BCF         TRISC2_bit+0, BitPos(TRISC2_bit+0) 
;MP3_Driver.mbas,134 :: 		MP3_RST           = 1                  'Set MP3_RST pin
	BSF         LATC2_bit+0, BitPos(LATC2_bit+0) 
;MP3_Driver.mbas,136 :: 		DREQ_Direction  = 1                    'Configure DREQ as input
	BSF         TRISC7_bit+0, BitPos(TRISC7_bit+0) 
;MP3_Driver.mbas,137 :: 		BSYNC_Direction = 0                    'Configure BSYNC as output
	BCF         TRISC6_bit+0, BitPos(TRISC6_bit+0) 
;MP3_Driver.mbas,138 :: 		BSYNC           = 0                    'Clear BSYNC
	BCF         LATC6_bit+0, BitPos(LATC6_bit+0) 
;MP3_Driver.mbas,141 :: 		SSP1Add = SPI_Slow                     'Creates a 208ns clock. a setting of five also works at a 170ns clock
	MOVLW       6
	MOVWF       SSP1ADD+0 
;MP3_Driver.mbas,143 :: 		SPI1_Init_Advanced(_SPI_Master_SSP1_Add, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_LOW_2_HIGH)
	MOVLW       10
	MOVWF       FARG_SPI1_Init_Advanced_master+0 
	CLRF        FARG_SPI1_Init_Advanced_data_sample+0 
	CLRF        FARG_SPI1_Init_Advanced_clock_idle+0 
	MOVLW       1
	MOVWF       FARG_SPI1_Init_Advanced_transmit_edge+0 
	CALL        _SPI1_Init_Advanced+0, 0
;MP3_Driver.mbas,145 :: 		Delay_ms(100)                          'SPI1 need a little time to settle
	MOVLW       9
	MOVWF       R11, 0
	MOVLW       30
	MOVWF       R12, 0
	MOVLW       228
	MOVWF       R13, 0
L__MP3_init7:
	DECFSZ      R13, 1, 1
	BRA         L__MP3_init7
	DECFSZ      R12, 1, 1
	BRA         L__MP3_init7
	DECFSZ      R11, 1, 1
	BRA         L__MP3_init7
	NOP
;MP3_Driver.mbas,147 :: 		MP3_RST = 0
	BCF         LATC2_bit+0, BitPos(LATC2_bit+0) 
;MP3_Driver.mbas,148 :: 		Delay_ms(10)
	MOVLW       208
	MOVWF       R12, 0
	MOVLW       201
	MOVWF       R13, 0
L__MP3_init8:
	DECFSZ      R13, 1, 1
	BRA         L__MP3_init8
	DECFSZ      R12, 1, 1
	BRA         L__MP3_init8
	NOP
	NOP
;MP3_Driver.mbas,149 :: 		MP3_RST = 1
	BSF         LATC2_bit+0, BitPos(LATC2_bit+0) 
;MP3_Driver.mbas,150 :: 		while (DREQ = 0) nop wend              'wait until DREQ becomes 1, see MP3 VS1053b datasheet, Serial Protocol for SCI
L__MP3_init10:
	BTFSC       RC7_bit+0, BitPos(RC7_bit+0) 
	GOTO        L__MP3_init11
	NOP
	GOTO        L__MP3_init10
L__MP3_init11:
;MP3_Driver.mbas,151 :: 		TMR0IE_bit         = 0                 'Disable Interrupt
	BCF         TMR0IE_bit+0, BitPos(TMR0IE_bit+0) 
;MP3_Driver.mbas,152 :: 		MP3_State = Write_SCI_State            'This is to avoid Re-Rntry problems
	MOVLW       8
	MOVWF       _MP3_State+0 
;MP3_Driver.mbas,153 :: 		Address = SCI_Mode_Addr
	CLRF        _Address+0 
;MP3_Driver.mbas,154 :: 		data_in = 0x0800                       'Rising Edge of the DCLOCK and others see Page 38 of VS1053 Data Sheet
	MOVLW       0
	MOVWF       _data_in+0 
	MOVLW       8
	MOVWF       _data_in+1 
;MP3_Driver.mbas,155 :: 		TMR0IE_bit         = 1                 'Let it run
	BSF         TMR0IE_bit+0, BitPos(TMR0IE_bit+0) 
;MP3_Driver.mbas,156 :: 		while MP3_State <> Idle nop wend       'Wait for it to finish
L__MP3_init15:
	MOVF        _MP3_State+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L__MP3_init16
	NOP
	GOTO        L__MP3_init15
L__MP3_init16:
;MP3_Driver.mbas,157 :: 		TMR0IE_bit         = 0                 'Disable Interrupt
	BCF         TMR0IE_bit+0, BitPos(TMR0IE_bit+0) 
;MP3_Driver.mbas,158 :: 		MP3_State = Write_SCI_State            'This is to avoid Re-Rntry problems
	MOVLW       8
	MOVWF       _MP3_State+0 
;MP3_Driver.mbas,159 :: 		Address = SCI_Bass_Addr
	MOVLW       2
	MOVWF       _Address+0 
;MP3_Driver.mbas,160 :: 		data_in = 0x7A00                       ''This sets the Bass Values see page 41 of the VS1053b Data Sheet
	MOVLW       0
	MOVWF       _data_in+0 
	MOVLW       122
	MOVWF       _data_in+1 
;MP3_Driver.mbas,161 :: 		TMR0IE_bit         = 1                 'Let it run
	BSF         TMR0IE_bit+0, BitPos(TMR0IE_bit+0) 
;MP3_Driver.mbas,162 :: 		while MP3_State <> Idle nop wend       'Wait for it to finish
L__MP3_init20:
	MOVF        _MP3_State+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L__MP3_init21
	NOP
	GOTO        L__MP3_init20
L__MP3_init21:
;MP3_Driver.mbas,163 :: 		TMR0IE_bit         = 0                 'Disable Interrupt
	BCF         TMR0IE_bit+0, BitPos(TMR0IE_bit+0) 
;MP3_Driver.mbas,164 :: 		MP3_State = Write_SCI_State            'This is to avoid Re-Rntry problems
	MOVLW       8
	MOVWF       _MP3_State+0 
;MP3_Driver.mbas,165 :: 		Address = SCI_CLOCKF_Addr
	MOVLW       3
	MOVWF       _Address+0 
;MP3_Driver.mbas,166 :: 		data_in = 0xC000                       'default 12 288 000 Hz + PLL * 4.5
	MOVLW       0
	MOVWF       _data_in+0 
	MOVLW       192
	MOVWF       _data_in+1 
;MP3_Driver.mbas,167 :: 		TMR0IE_bit         = 1                 'Let it run
	BSF         TMR0IE_bit+0, BitPos(TMR0IE_bit+0) 
;MP3_Driver.mbas,168 :: 		while MP3_State <> Idle nop wend       'Wait for it to finish
L__MP3_init25:
	MOVF        _MP3_State+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L__MP3_init26
	NOP
	GOTO        L__MP3_init25
L__MP3_init26:
;MP3_Driver.mbas,171 :: 		Volume_Level_Pointer = Initial_Volume  ' Point to Mid range' initial volume
	MOVLW       5
	MOVWF       _Volume_Level_Pointer+0 
;MP3_Driver.mbas,172 :: 		MP3_Set_Volume
	CALL        _MP3_Set_Volume+0, 0
;MP3_Driver.mbas,174 :: 		end sub
L_end_MP3_init:
	RETURN      0
; end of _MP3_init

_MP3_Check_Volume:

;MP3_Driver.mbas,178 :: 		dim Old_Volume_Level as byte
;MP3_Driver.mbas,180 :: 		Old_Volume_Level = Volume_Level_Pointer   'save volume Level
	MOVF        _Volume_Level_Pointer+0, 0 
	MOVWF       MP3_Check_Volume_Old_Volume_Level+0 
;MP3_Driver.mbas,182 :: 		if (Btn_Volume_Up)
	BTFSS       RD1_bit+0, BitPos(RD1_bit+0) 
	GOTO        L__MP3_Check_Volume31
;MP3_Driver.mbas,184 :: 		while (Btn_Volume_Up)             'Wait for button UP They are pulled down
L__MP3_Check_Volume34:
	BTFSS       RD1_bit+0, BitPos(RD1_bit+0) 
	GOTO        L__MP3_Check_Volume35
;MP3_Driver.mbas,185 :: 		nop
	NOP
;MP3_Driver.mbas,186 :: 		wend
	GOTO        L__MP3_Check_Volume34
L__MP3_Check_Volume35:
;MP3_Driver.mbas,187 :: 		if (Volume_Level_Pointer = 10)    'Setting 11 is the upper limit
	MOVF        _Volume_Level_Pointer+0, 0 
	XORLW       10
	BTFSS       STATUS+0, 2 
	GOTO        L__MP3_Check_Volume39
;MP3_Driver.mbas,189 :: 		exit                         'Don't roll over
	GOTO        L_end__MP3_Check_Volume
;MP3_Driver.mbas,190 :: 		else
L__MP3_Check_Volume39:
;MP3_Driver.mbas,191 :: 		Inc(Volume_Level_Pointer)    'Point to the next number in the table
	INCF        _Volume_Level_Pointer+0, 1 
;MP3_Driver.mbas,192 :: 		end if
L__MP3_Check_Volume31:
;MP3_Driver.mbas,196 :: 		if (Btn_Volume_Dn) then             'RD0 pressed = VOLUME DOWN command
	BTFSS       RD0_bit+0, BitPos(RD0_bit+0) 
	GOTO        L__MP3_Check_Volume42
;MP3_Driver.mbas,197 :: 		while (Btn_Volume_Dn)             'Wait for button UP They are pulled down
L__MP3_Check_Volume45:
	BTFSS       RD0_bit+0, BitPos(RD0_bit+0) 
	GOTO        L__MP3_Check_Volume46
;MP3_Driver.mbas,198 :: 		nop
	NOP
;MP3_Driver.mbas,199 :: 		wend
	GOTO        L__MP3_Check_Volume45
L__MP3_Check_Volume46:
;MP3_Driver.mbas,200 :: 		if (Volume_Level_Pointer = 0)     'Zero is the lower limit
	MOVF        _Volume_Level_Pointer+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__MP3_Check_Volume50
;MP3_Driver.mbas,202 :: 		exit                         'So don't go out of the Array
	GOTO        L_end__MP3_Check_Volume
;MP3_Driver.mbas,203 :: 		else
L__MP3_Check_Volume50:
;MP3_Driver.mbas,204 :: 		DEC(Volume_Level_Pointer)    'Point to the next number in the table
	DECF        _Volume_Level_Pointer+0, 1 
;MP3_Driver.mbas,205 :: 		end if
L__MP3_Check_Volume42:
;MP3_Driver.mbas,210 :: 		if  (Old_Volume_Level <> Volume_Level_Pointer)
	MOVF        MP3_Check_Volume_Old_Volume_Level+0, 0 
	XORWF       _Volume_Level_Pointer+0, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__MP3_Check_Volume53
;MP3_Driver.mbas,213 :: 		MP3_Set_Volume
	CALL        _MP3_Set_Volume+0, 0
L__MP3_Check_Volume53:
;MP3_Driver.mbas,215 :: 		end sub
L_end__MP3_Check_Volume:
L_end_MP3_Check_Volume:
	RETURN      0
; end of _MP3_Check_Volume

_Play_Mp3:

;MP3_Driver.mbas,217 :: 		Sub Procedure Play_Mp3
;MP3_Driver.mbas,221 :: 		case Idle                              'Nothing requested
	MOVF        _MP3_State+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__Play_Mp359
;MP3_Driver.mbas,222 :: 		exit                             'Get out as quick as possible
	GOTO        L_end__Play_Mp3
L__Play_Mp359:
;MP3_Driver.mbas,225 :: 		case DREQ_State
	MOVF        _MP3_State+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__Play_Mp362
;MP3_Driver.mbas,227 :: 		if DREQ = 0
	BTFSC       RC7_bit+0, BitPos(RC7_bit+0) 
	GOTO        L__Play_Mp364
;MP3_Driver.mbas,229 :: 		exit                           'It's Busy Give time back to the main program
	GOTO        L_end__Play_Mp3
;MP3_Driver.mbas,230 :: 		else
L__Play_Mp364:
;MP3_Driver.mbas,231 :: 		MP3_State = DREQ_Return_State  'Caller must set this next state to run
	MOVF        _DREQ_Return_State+0, 0 
	MOVWF       _MP3_State+0 
;MP3_Driver.mbas,232 :: 		goto Play_MP3                  'Must force the next state because DREQ is high
	GOTO        _Play_Mp3+0
;MP3_Driver.mbas,233 :: 		end if
	GOTO        L__Play_Mp356
L__Play_Mp362:
;MP3_Driver.mbas,235 :: 		case Initialized
	MOVF        _MP3_State+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__Play_Mp368
;MP3_Driver.mbas,236 :: 		if Mmc_Fat_Init = 0                'Is the card formatted FAT-16 ?
	CALL        _Mmc_Fat_Init+0, 0
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__Play_Mp370
;MP3_Driver.mbas,238 :: 		if Mmc_Fat_Assign (Filename,0) = 1 'Yes..Check the File Name
	MOVLW       _Filename+0
	MOVWF       FARG_Mmc_Fat_Assign_name+0 
	MOVLW       hi_addr(_Filename+0)
	MOVWF       FARG_Mmc_Fat_Assign_name+1 
	CLRF        FARG_Mmc_Fat_Assign_attrib+0 
	CALL        _Mmc_Fat_Assign+0, 0
	MOVF        R0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__Play_Mp373
;MP3_Driver.mbas,240 :: 		Mmc_Fat_Reset (File_Size)  'Reset to start of file  and get File Length
	MOVLW       _File_Size+0
	MOVWF       FARG_Mmc_Fat_Reset_size+0 
	MOVLW       hi_addr(_File_Size+0)
	MOVWF       FARG_Mmc_Fat_Reset_size+1 
	CALL        _Mmc_Fat_Reset+0, 0
;MP3_Driver.mbas,241 :: 		SSP1Add = SPI_Fast         'Set SIP to Fast for SD Card Read
	MOVLW       2
	MOVWF       SSP1ADD+0 
;MP3_Driver.mbas,242 :: 		Mp3_State = Send_Block     'And send this File
	MOVLW       3
	MOVWF       _MP3_State+0 
	GOTO        L__Play_Mp374
;MP3_Driver.mbas,243 :: 		else
L__Play_Mp373:
;MP3_Driver.mbas,244 :: 		MP3_State =  Idle         'File doesn't exist, nothing we can do here
	CLRF        _MP3_State+0 
;MP3_Driver.mbas,245 :: 		end if
L__Play_Mp374:
	GOTO        L__Play_Mp371
;MP3_Driver.mbas,246 :: 		else
L__Play_Mp370:
;MP3_Driver.mbas,247 :: 		MP3_State = IDLE                'SD Card not Formatted, nothing to do
	CLRF        _MP3_State+0 
;MP3_Driver.mbas,248 :: 		end if
L__Play_Mp371:
	GOTO        L__Play_Mp356
L__Play_Mp368:
;MP3_Driver.mbas,250 :: 		case Send_Block                        'This state looks for End of File
	MOVF        _MP3_State+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L__Play_Mp377
;MP3_Driver.mbas,251 :: 		if File_Size <= Buffer_Size       'And Starts the SD Card read routine
	MOVF        _File_Size+3, 0 
	SUBLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__Play_Mp3127
	MOVF        _File_Size+2, 0 
	SUBLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__Play_Mp3127
	MOVF        _File_Size+1, 0 
	SUBLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__Play_Mp3127
	MOVF        _File_Size+0, 0 
	SUBLW       192
L__Play_Mp3127:
	BTFSS       STATUS+0, 0 
	GOTO        L__Play_Mp379
;MP3_Driver.mbas,253 :: 		MP3_State = Read_End_Of_File  'Were at End Of File go do a partial Buffer
	MOVLW       6
	MOVWF       _MP3_State+0 
;MP3_Driver.mbas,254 :: 		Bytes_2_Read = 0              'Housekeeping fot the Read End Of File Routine
	CLRF        _Bytes_2_Read+0 
	CLRF        _Bytes_2_Read+1 
;MP3_Driver.mbas,255 :: 		SSPAdd = SPI_Fast             'Speed up the SPI
	MOVLW       2
	MOVWF       SSPADD+0 
;MP3_Driver.mbas,256 :: 		Goto Play_MP3                 'Don't give it back yet. Do it now
	GOTO        _Play_Mp3+0
	GOTO        L__Play_Mp380
;MP3_Driver.mbas,257 :: 		else
L__Play_Mp379:
;MP3_Driver.mbas,258 :: 		MP3_State = Read_SD_Data      'Not End Of File read a full Buffer's wort of Data
	MOVLW       4
	MOVWF       _MP3_State+0 
;MP3_Driver.mbas,259 :: 		Bytes_2_Read = 0              'Housekeeping fot the Read SD Data Routine
	CLRF        _Bytes_2_Read+0 
	CLRF        _Bytes_2_Read+1 
;MP3_Driver.mbas,260 :: 		goto Play_MP3                 'Don't give it back yet. Do it now
	GOTO        _Play_Mp3+0
;MP3_Driver.mbas,261 :: 		end if
L__Play_Mp380:
	GOTO        L__Play_Mp356
L__Play_Mp377:
;MP3_Driver.mbas,264 :: 		case Read_SD_Data
	MOVF        _MP3_State+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L__Play_Mp383
;MP3_Driver.mbas,265 :: 		Read_SD_Data:                                  'Read a Full Buffer from the SD Card
L__Play_Mp3_read_sd_data:
;MP3_Driver.mbas,266 :: 		Mmc_Chip_Select =0                'Enable the SD Card
	BCF         LATC0_bit+0, BitPos(LATC0_bit+0) 
;MP3_Driver.mbas,267 :: 		Mmc_Fat_Read (MP3_Buffer [Bytes_2_Read]) 'Read a byte
	MOVLW       _MP3_Buffer+0
	ADDWF       _Bytes_2_Read+0, 0 
	MOVWF       FARG_Mmc_Fat_Read_fdata+0 
	MOVLW       hi_addr(_MP3_Buffer+0)
	ADDWFC      _Bytes_2_Read+1, 0 
	MOVWF       FARG_Mmc_Fat_Read_fdata+1 
	CALL        _Mmc_Fat_Read+0, 0
;MP3_Driver.mbas,268 :: 		Mmc_Chip_Select =1                'Manage CS
	BSF         LATC0_bit+0, BitPos(LATC0_bit+0) 
;MP3_Driver.mbas,269 :: 		inc (Bytes_2_Read)                'Next Byte
	INFSNZ      _Bytes_2_Read+0, 1 
	INCF        _Bytes_2_Read+1, 1 
;MP3_Driver.mbas,270 :: 		if Bytes_2_Read = Buffer_Size     'Are we done?
	MOVF        _Bytes_2_Read+1, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__Play_Mp3128
	MOVLW       192
	XORWF       _Bytes_2_Read+0, 0 
L__Play_Mp3128:
	BTFSS       STATUS+0, 2 
	GOTO        L__Play_Mp386
;MP3_Driver.mbas,272 :: 		mp3_State = Write_To_VS1053b 'Yes switch states to write it to the VS1035b
	MOVLW       5
	MOVWF       _MP3_State+0 
;MP3_Driver.mbas,273 :: 		Bytes_2_Write_Counter = 0    'Housekeeping for Write To VS1053b Routine
	CLRF        _Bytes_2_Write_Counter+0 
;MP3_Driver.mbas,274 :: 		Blocks_2_Write = 0           'It can only write 32 bytes before checking DREQ
	CLRF        _Blocks_2_Write+0 
;MP3_Driver.mbas,275 :: 		SSPAdd = SPI_Slow            'Slow down the SPI Bus for the VS1053b
	MOVLW       6
	MOVWF       SSPADD+0 
;MP3_Driver.mbas,276 :: 		File_Size = File_Size - Buffer_Size 'Reduce File Size by this Buffer's length
	MOVLW       192
	SUBWF       _File_Size+0, 1 
	MOVLW       1
	SUBWFB      _File_Size+1, 1 
	MOVLW       0
	SUBWFB      _File_Size+2, 1 
	SUBWFB      _File_Size+3, 1 
;MP3_Driver.mbas,277 :: 		goto Play_MP3                'Get to the write routine quickly
	GOTO        _Play_Mp3+0
L__Play_Mp386:
;MP3_Driver.mbas,279 :: 		goto Read_SD_Data            'Not a full Buffer yet Loop
	GOTO        L__Play_Mp3_read_sd_data
L__Play_Mp383:
;MP3_Driver.mbas,281 :: 		case Write_To_VS1053b                 'Writes Blocks of 32 Bytes to the VS1053b
	MOVF        _MP3_State+0, 0 
	XORLW       5
	BTFSS       STATUS+0, 2 
	GOTO        L__Play_Mp390
;MP3_Driver.mbas,282 :: 		Write_To_VS1053b:                                'in 32 byte chuncks
L__Play_Mp3_write_to_vs1053b:
;MP3_Driver.mbas,283 :: 		if Blocks_2_Write <> Buffer_Size / Bytes_2_Write
	MOVF        _Blocks_2_Write+0, 0 
	XORLW       14
	BTFSC       STATUS+0, 2 
	GOTO        L__Play_Mp393
;MP3_Driver.mbas,285 :: 		BSYNC = 0              'This is in the VS1053b Data Sheet
	BCF         LATC6_bit+0, BitPos(LATC6_bit+0) 
;MP3_Driver.mbas,287 :: 		Data_ = ((@MP3_Buffer + (Blocks_2_Write* Bytes_2_write)) + Bytes_2_Write_Counter)
	MOVLW       5
	MOVWF       R2 
	MOVF        _Blocks_2_Write+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        R2, 0 
L__Play_Mp3129:
	BZ          L__Play_Mp3130
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	ADDLW       255
	GOTO        L__Play_Mp3129
L__Play_Mp3130:
	MOVLW       _MP3_Buffer+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_MP3_Buffer+0)
	ADDWFC      R1, 1 
	MOVF        _Bytes_2_Write_Counter+0, 0 
	ADDWF       R0, 1 
	MOVLW       0
	ADDWFC      R1, 1 
	MOVF        R0, 0 
	MOVWF       _Data_+0 
	MOVF        R1, 0 
	MOVWF       _Data_+1 
;MP3_Driver.mbas,288 :: 		MP3_cs = 0             'Enable the VS1053b
	BCF         LATC1_bit+0, BitPos(LATC1_bit+0) 
;MP3_Driver.mbas,289 :: 		SPI1_Write (Data_^)    'and write this byte
	MOVFF       R0, FSR0
	MOVFF       R1, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;MP3_Driver.mbas,290 :: 		Mp3_cs = 1             'Manage CS
	BSF         LATC1_bit+0, BitPos(LATC1_bit+0) 
;MP3_Driver.mbas,291 :: 		inc (Bytes_2_Write_Counter) 'Bump the counter for this byte
	INCF        _Bytes_2_Write_Counter+0, 1 
;MP3_Driver.mbas,292 :: 		if Bytes_2_Write_Counter <> 32 'Have we done 32 bytes?
	MOVF        _Bytes_2_Write_Counter+0, 0 
	XORLW       32
	BTFSC       STATUS+0, 2 
	GOTO        L__Play_Mp396
;MP3_Driver.mbas,294 :: 		GOTO Write_To_VS1053b 'So fill it up
	GOTO        L__Play_Mp3_write_to_vs1053b
;MP3_Driver.mbas,295 :: 		else            '32 Bytes have been written
L__Play_Mp396:
;MP3_Driver.mbas,296 :: 		BSYNC = 1     'It's in the VS1053b Data Sheet
	BSF         LATC6_bit+0, BitPos(LATC6_bit+0) 
;MP3_Driver.mbas,299 :: 		DREQ_Return_State = Write_To_VS1053b
	MOVLW       5
	MOVWF       _DREQ_Return_State+0 
;MP3_Driver.mbas,300 :: 		MP3_State = DREQ_State 'Set the STATE to DREQ
	MOVLW       1
	MOVWF       _MP3_State+0 
;MP3_Driver.mbas,301 :: 		Bytes_2_write_Counter = 0 'Housekeeping for when we come back
	CLRF        _Bytes_2_Write_Counter+0 
;MP3_Driver.mbas,302 :: 		inc (Blocks_2_Write)      'Count the Chunck of 32 Bytes
	INCF        _Blocks_2_Write+0, 1 
;MP3_Driver.mbas,303 :: 		goto Play_MP3             'Keep streaming it out
	GOTO        _Play_Mp3+0
;MP3_Driver.mbas,305 :: 		end if
	GOTO        L__Play_Mp394
;MP3_Driver.mbas,306 :: 		else                                'Done with this Buffer come here
L__Play_Mp393:
;MP3_Driver.mbas,307 :: 		BSYNC = 1                        'More VS1053b requirements
	BSF         LATC6_bit+0, BitPos(LATC6_bit+0) 
;MP3_Driver.mbas,308 :: 		MP3_State = Send_Block           'Get another Buffer of data
	MOVLW       3
	MOVWF       _MP3_State+0 
;MP3_Driver.mbas,309 :: 		goto Play_MP3                    'Send Block looks for End Of File
	GOTO        _Play_Mp3+0
;MP3_Driver.mbas,310 :: 		end if
L__Play_Mp394:
	GOTO        L__Play_Mp356
L__Play_Mp390:
;MP3_Driver.mbas,312 :: 		case Read_End_Of_File                            'End Of File is a short Buffer
	MOVF        _MP3_State+0, 0 
	XORLW       6
	BTFSS       STATUS+0, 2 
	GOTO        L__Play_Mp3100
;MP3_Driver.mbas,313 :: 		Read_End_Of_File:
L__Play_Mp3_read_end_of_file:
;MP3_Driver.mbas,314 :: 		Mmc_Chip_Select = 0                      'Enable the SD Card
	BCF         LATC0_bit+0, BitPos(LATC0_bit+0) 
;MP3_Driver.mbas,315 :: 		Mmc_Fat_Read (Mp3_Buffer [Bytes_2_Read]) 'Read a byte
	MOVLW       _MP3_Buffer+0
	ADDWF       _Bytes_2_Read+0, 0 
	MOVWF       FARG_Mmc_Fat_Read_fdata+0 
	MOVLW       hi_addr(_MP3_Buffer+0)
	ADDWFC      _Bytes_2_Read+1, 0 
	MOVWF       FARG_Mmc_Fat_Read_fdata+1 
	CALL        _Mmc_Fat_Read+0, 0
;MP3_Driver.mbas,316 :: 		Mmc_Chip_Select =1                       'Manage CS
	BSF         LATC0_bit+0, BitPos(LATC0_bit+0) 
;MP3_Driver.mbas,317 :: 		inc (Bytes_2_Read)                       'Count this byte
	INFSNZ      _Bytes_2_Read+0, 1 
	INCF        _Bytes_2_Read+1, 1 
;MP3_Driver.mbas,318 :: 		if Bytes_2_Read = File_Size              'Is this the last Byte?
	MOVLW       0
	MOVWF       R0 
	XORWF       _File_Size+3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Play_Mp3131
	MOVF        R0, 0 
	XORWF       _File_Size+2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Play_Mp3131
	MOVF        _Bytes_2_Read+1, 0 
	XORWF       _File_Size+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Play_Mp3131
	MOVF        _File_Size+0, 0 
	XORWF       _Bytes_2_Read+0, 0 
L__Play_Mp3131:
	BTFSS       STATUS+0, 2 
	GOTO        L__Play_Mp3103
;MP3_Driver.mbas,320 :: 		MP3_State = Write_End_Of_File        'Yes write the data
	MOVLW       7
	MOVWF       _MP3_State+0 
;MP3_Driver.mbas,321 :: 		SSPADD = SPI_Slow                    'Slow down the SPI for Writing to the VS1053b
	MOVLW       6
	MOVWF       SSPADD+0 
;MP3_Driver.mbas,322 :: 		Bytes_2_Write_Counter = 0            'Housekeeping for Write End Of File
	CLRF        _Bytes_2_Write_Counter+0 
;MP3_Driver.mbas,323 :: 		goto Play_MP3                        'Do it now to reduce stuttering
	GOTO        _Play_Mp3+0
L__Play_Mp3103:
;MP3_Driver.mbas,325 :: 		goto Read_End_Of_File                  'Get the rest of the data
	GOTO        L__Play_Mp3_read_end_of_file
L__Play_Mp3100:
;MP3_Driver.mbas,328 :: 		case Write_End_Of_File                          'Write the End Of File Data
	MOVF        _MP3_State+0, 0 
	XORLW       7
	BTFSS       STATUS+0, 2 
	GOTO        L__Play_Mp3107
;MP3_Driver.mbas,329 :: 		Write_End_Of_File:
L__Play_Mp3_write_end_of_file:
;MP3_Driver.mbas,331 :: 		Data_ = @MP3_Buffer + Bytes_2_Write_Counter
	MOVLW       _MP3_Buffer+0
	MOVWF       R0 
	MOVLW       hi_addr(_MP3_Buffer+0)
	MOVWF       R1 
	MOVF        _Bytes_2_Write_Counter+0, 0 
	ADDWF       R0, 1 
	BTFSC       STATUS+0, 0 
	INCF        R1, 1 
	MOVF        R0, 0 
	MOVWF       _Data_+0 
	MOVF        R1, 0 
	MOVWF       _Data_+1 
;MP3_Driver.mbas,332 :: 		BSYNC = 0                          'In the VS1053b Data sheet
	BCF         LATC6_bit+0, BitPos(LATC6_bit+0) 
;MP3_Driver.mbas,333 :: 		MP3_cs = 0                         'Enable the VS1053b
	BCF         LATC1_bit+0, BitPos(LATC1_bit+0) 
;MP3_Driver.mbas,334 :: 		SPI1_Write (Data_^)                'and write the data
	MOVFF       R0, FSR0
	MOVFF       R1, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;MP3_Driver.mbas,335 :: 		MP3_cs = 1                         'Manage CS
	BSF         LATC1_bit+0, BitPos(LATC1_bit+0) 
;MP3_Driver.mbas,336 :: 		dec (File_Size)                    'File Size has the Byte Count to write
	MOVLW       1
	SUBWF       _File_Size+0, 1 
	MOVLW       0
	SUBWFB      _File_Size+1, 1 
	SUBWFB      _File_Size+2, 1 
	SUBWFB      _File_Size+3, 1 
;MP3_Driver.mbas,337 :: 		BSYNC = 1                          'In the VS1053b Data sheet
	BSF         LATC6_bit+0, BitPos(LATC6_bit+0) 
;MP3_Driver.mbas,338 :: 		inc (Bytes_2_Write_Counter)        'Count the Bytes Written
	INCF        _Bytes_2_Write_Counter+0, 1 
;MP3_Driver.mbas,339 :: 		if  File_Size = 0                  'Are we done yet?
	MOVLW       0
	MOVWF       R0 
	XORWF       _File_Size+3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Play_Mp3132
	MOVF        R0, 0 
	XORWF       _File_Size+2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Play_Mp3132
	MOVF        R0, 0 
	XORWF       _File_Size+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Play_Mp3132
	MOVF        _File_Size+0, 0 
	XORLW       0
L__Play_Mp3132:
	BTFSS       STATUS+0, 2 
	GOTO        L__Play_Mp3110
;MP3_Driver.mbas,341 :: 		MP3_State = Idle              'Yes reset the Server
	CLRF        _MP3_State+0 
;MP3_Driver.mbas,342 :: 		exit                          'And wait for the next task
	GOTO        L_end__Play_Mp3
;MP3_Driver.mbas,343 :: 		else                            'Not done yet
L__Play_Mp3110:
;MP3_Driver.mbas,344 :: 		if Bytes_2_Write_Counter <> Bytes_2_Write 'Look for the 32 byte chunk
	MOVF        _Bytes_2_Write_Counter+0, 0 
	XORLW       32
	BTFSC       STATUS+0, 2 
	GOTO        L__Play_Mp3113
;MP3_Driver.mbas,346 :: 		goto Write_End_Of_File    'Not yet keep writing
	GOTO        L__Play_Mp3_write_end_of_file
;MP3_Driver.mbas,347 :: 		else                        '32 bytes have been written
L__Play_Mp3113:
;MP3_Driver.mbas,348 :: 		Bytes_2_write_counter = 0 'Reset the Chunk Byte counter
	CLRF        _Bytes_2_Write_Counter+0 
;MP3_Driver.mbas,350 :: 		DREQ_Return_State = Write_End_Of_File 'Need to wait for DREQ
	MOVLW       7
	MOVWF       _DREQ_Return_State+0 
;MP3_Driver.mbas,351 :: 		MP3_State = DREQ_State    'wait for DREQ. DREQ gives up the Processor
	MOVLW       1
	MOVWF       _MP3_State+0 
;MP3_Driver.mbas,354 :: 		end if
	GOTO        L__Play_Mp356
L__Play_Mp3107:
;MP3_Driver.mbas,356 :: 		case Write_SCI_State             'Write a command to the VS1053b
	MOVF        _MP3_State+0, 0 
	XORLW       8
	BTFSS       STATUS+0, 2 
	GOTO        L__Play_Mp3117
;MP3_Driver.mbas,357 :: 		BSYNC = 1
	BSF         LATC6_bit+0, BitPos(LATC6_bit+0) 
;MP3_Driver.mbas,358 :: 		MP3_CS = 0               'select MP3 SPI
	BCF         LATC1_bit+0, BitPos(LATC1_bit+0) 
;MP3_Driver.mbas,359 :: 		SPI1_Write(WRITE_CODE)   'From the Data Sheet
	MOVLW       2
	MOVWF       FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;MP3_Driver.mbas,360 :: 		SPI1_Write(address)      'Passed by the caller
	MOVF        _Address+0, 0 
	MOVWF       FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;MP3_Driver.mbas,361 :: 		SPI1_Write(Hi(data_in))  'high byte sending 16 Bits a Byte at a time
	MOVF        _data_in+1, 0 
	MOVWF       FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;MP3_Driver.mbas,362 :: 		SPI1_Write(Lo(data_in))  'low byte
	MOVF        _data_in+0, 0 
	MOVWF       FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;MP3_Driver.mbas,363 :: 		MP3_CS = 1               'deselect MP3 SCI
	BSF         LATC1_bit+0, BitPos(LATC1_bit+0) 
;MP3_Driver.mbas,364 :: 		while (DREQ = 0) nop wend'wait until DREQ becomes 1, see MP3 VS1053b datasheet, Serial Protocol for SCI
L__Play_Mp3119:
	BTFSC       RC7_bit+0, BitPos(RC7_bit+0) 
	GOTO        L__Play_Mp3120
	NOP
	GOTO        L__Play_Mp3119
L__Play_Mp3120:
;MP3_Driver.mbas,365 :: 		MP3_State = Idle         'Put the State Machine back to Idle Ready for next Task
	CLRF        _MP3_State+0 
	GOTO        L__Play_Mp356
L__Play_Mp3117:
L__Play_Mp356:
;MP3_Driver.mbas,367 :: 		end sub
L_end__Play_Mp3:
L_end_Play_Mp3:
	RETURN      0
; end of _Play_Mp3
